public class Simulator extends Fehlerfunktion
{
        public int C, D;
        public int[] param = {0,0};
        double[] y0 = {1.0,0.0}; //Anfangsbedingungen
        double[] y_real = new double[100];  //Merker fr "reale Welt"
        double[] y_sim  = new double[100];  //Merker fr Testsimulation mit Parametern, die von Evoopt kommen

         SchwingerModell modell;
         RuKuIntegrator integrator;
         double[] y = {1.0,0.0};

        Simulator(int C, int D)
        {
            this.C = C;
            this.D = D;

            modell = new SchwingerModell(0.01*(double)C,0.01*(double)D,1.0);
            integrator = new RuKuIntegrator(modell);
            integrator.setzeAnfangsbedingungen(y0);
            for(int i=0;i<100;i++) //Sttzpunkte von realem System vorbereiten.
            {
                 y_real[i] = integrator.y[0];
                 integrator.zeitschritt(0.1);
            }            
        }

        public double berechneFehler(int[] par)
        {
            double fehler = 0.0;
            
            modell.C = 0.01*(double)par[0];
            modell.D = 0.01*(double)par[1];
            modell.m = 1.0;
            integrator.setzeAnfangsbedingungen(y0);
            
            for(int i=0;i<100;i++) //Sttzpunkte von realem System vorbereiten.
            {
                 fehler+= (y_real[i] - integrator.y[0])*(y_real[i] - integrator.y[0]);
                 integrator.zeitschritt(0.1);
            }                        
            
            return fehler;
        }
    
        public static void main(String[] args)
        {        
            Simulator simulator = new Simulator(100,50);  //C=1.0, D=0.5 (wird durch 100 geteilt.)            
            Evoopt evoopt = new Evoopt(simulator);   
                               
            for(int i=0;i<10;i++)
            {
              evoopt.erzeugeNeueGeneration();
              if(i>0 && i%1==0)
              {
                System.out.println("Gen."+evoopt.generation_nr+" Fehler:"+evoopt.fehler_minimal
                +" C="+evoopt.psatz_allerbest[0]
                +" D="+evoopt.psatz_allerbest[1]);            
              }                
            }    
            
        }        
}